<template>
  <div class="page">
    <jobs-list :job-id="jobId" :jobs="jobs" @job="setJob" />
    <q-page-sticky v-if="isAuth" position="top-right" :offset="[5, 5]">
      <q-fab
        class="q-btn–fab-mini"
        icon="add"
        direction="left"
        color="primary"
        size="sm"
      >
        <q-fab-action color="primary" icon="logout" @click="logout">
          <q-tooltip>{{ $t('logout') }}</q-tooltip>
        </q-fab-action>
        <q-fab-action color="primary" icon="poll" @click="fetchData">
          <q-tooltip>{{ $t('nav.statistics') }}</q-tooltip>
        </q-fab-action>
      </q-fab>
    </q-page-sticky>
    <q-card v-if="job.title">
      <q-card-section v-if="$q.screen.gt.xs" class="row">
        <div class="col-lg-3 col-xl-2 col-md-4 col-xs-3 col-sm-5">
          <logo :logo-url="orgLogo" />
        </div>
        <div class="col-lg-9 col-xl-10 col-md-8 col-xs-9 col-sm-7">
          <div class="text-h6 q-ml-md text-primary mobile-hide">
            {{ $t('Über GHG') }}
          </div>
          <div class="q-ml-md">
            {{ general.description }}
          </div>
        </div>
      </q-card-section>
      <q-card-section v-else>
        <logo :logo-url="orgLogo" width="100px" class="float-left" />
        {{ general.description }}
      </q-card-section>
      <q-card-section>
        <div class="text-h6 text-center ">{{ general.intro }}</div>
      </q-card-section>
      <q-card-section>
        <div class="text-h4 text-center text-primary">
          {{ job.title }}<br>
          <q-btn
            rounded
            ping="https://api.yawik.org/api/stats"
            size="lg"
            class="q-mt-md pulse"
            color="secondary"
            :label="$t('buttons.apply')"
            @click="startApplication"
          />
        </div>
      </q-card-section>

      <q-card-section>
        <div class="text-h6 text-primary">{{ job.benefits?.label ? job.benefits.label : general.benefits.label }}</div>
        <div class="row">
          <q-list class="col-md-6 col-sm-12">
            <q-item v-for="item in benefits" :key="item.label">
              <q-item-section avatar>
                <q-icon
                  size="xl"
                  :name="item.logo"
                  color="primary"
                />
              </q-item-section>
              <q-item-section side>
                {{ item.desc }}
              </q-item-section>
            </q-item>
          </q-list>

          <q-carousel
            v-model="slide"
            swipeable
            animated
            navigation
            infinite
            class="col-5"
          >
            <q-carousel-slide class="gt-md" :name="1" img-src="https://www.g-h-g.de/media/de/unternehmen/shk/ueber_uns/ueberuns_gross.jpg" />
            <q-carousel-slide class="gt-md" :name="2" img-src="GHG-Auto-vor-Frankfurter-Skyline.jpg" />
          </q-carousel>
        </div>
      </q-card-section>

      <q-card-section>
        <div class="row">
          <q-list class="col-md-6 col-sm-12 col-xs-12">
            <q-item-label class="text-primary text-h5" header>{{ job.profile?.label }}</q-item-label>
            <q-item v-for="(item, i) in profile" :key="i">
              <q-item-section avatar>
                <q-icon
                  name="check"
                  color="secondary"
                />
              </q-item-section>
              <q-item-section side>
                {{ item }}
              </q-item-section>
            </q-item>
          </q-list>
          <q-list class="col-md-6 col-sm-12 col-xs-12">
            <q-item-label class="text-primary text-h5" header>{{ job.tasks?.label }}</q-item-label>
            <q-item v-for="(item, index) in tasks" :key="index">
              <q-item-section avatar>
                <q-icon
                  name="check"
                  color="secondary"
                />
              </q-item-section>
              <q-item-section side>
                {{ item }}
              </q-item-section>
            </q-item>
          </q-list>
        </div>
      </q-card-section>

      <q-separator dark />

      <q-card-actions align="around">
        <q-btn
          rounded
          size="lg"
          color="secondary"
          class="pulse"
          :label="$t('buttons.apply')"
          @click="startApplication"
        />
      </q-card-actions>
    </q-card>
    <q-dialog
      v-model="persistent"
      persistent
      transition-show="scale"
      transition-hide="scale"
    >
      <q-card class="text-white" style="width: 400px;">
        <q-bar class="bg-primary text-white" style="width: 400px;">
          <div class="cursor-pointer">{{ job.title }}</div>
          <q-space />
          <q-btn dense flat icon="close" @click="persistent = false" />
        </q-bar>
        <questions :job="job" @submit="persistent = false" />
      </q-card>
    </q-dialog>
    <dialog-statistics :statistics="statistics" @close="statistics = false" />
  </div>
</template>

<script>
import {
  SET_TOKEN,
  SET_UUID,
  GET_STATS,
  HAS_AUTH,
  SET_DATE_CREATED,
  SET_DATE_MODIFIED,
  SET_PLATFORM
} from '../store/names';
import createJsondLd from 'src/lib/createJsonLd.js';
import { defineComponent, ref } from 'vue';
import { uid, useMeta } from 'quasar';
import JobsData from 'src/data/jobs.json';
import JobsList from 'src/components/JobsList';
import Questions from 'src/components/Questions';
import general from 'src/data/general.json';
import Logo from 'src/components/Logo';
import { mapGetters, mapMutations } from 'vuex';
import DialogStatistics from 'src/components/dialogs/DialogStatistics';

export default defineComponent({
  name: 'Job',
  components: {
    JobsList,
    Logo,
    Questions,
    DialogStatistics
  },
  emits: ['apply'],
  setup()
  {
    const title = ref('Stellenanzeigen der GHG GmbH');
    const description = ref('Aktuelle Stellenanzeigen im Bereich Klima, Heizung und Sanitär');
    const keywords = ref('Stellenanzeigen Klima, Heizung, Sanitär. SHK');
    const job = ref({});

    useMeta(() =>
    {
      return {
        // whenever "title" from above changes, your meta will automatically update
        title: title.value,
        titleTemplate: title => `${title} @ Bewirb dich bei der GHG`,
        meta: {
          description: {
            name: 'description',
            content: description.value
          },
          keywords: {
            name: 'keywords',
            content: keywords.value
          },
        },
        script: {
          job: {
            type: 'application/ld+json',
            innerHTML: job.value
          }
        },
      };
    });

    function pageTitle(val)
    {
      title.value = val; // will automatically trigger a Meta update due to the binding
    }

    function pageKeywords(val)
    {
      title.value = val; // will automatically trigger a Meta update due to the binding
    }

    function pageDescription(val)
    {
      description.value = val; // will automatically trigger a Meta update due to the binding
    }

    function pageJob(val)
    {
      job.value = val; // will automatically trigger a Meta update due to the binding
    }

    return {
      jobId: ref(0),
      persistent: ref(false),
      onClick()
      {
        console.log('Clicked on a fab action');
      },
      pageTitle,
      pageDescription,
      pageKeywords,
      pageJob
    };
  },
  data()
  {
    return {
      apply: false,
      statistics: false,
      slide: 1,
      stats: {
        data: {
          visit: 0,
          views: 1,
          clicks: 0,
          duration: 0
        },
        job: ''
      },
      job: JobsData[this.jobId],
      orgLogo: this.orgLogo ? this.orgLogo : 'logo.png',
    };
  },
  computed:
  {
    ...mapGetters([HAS_AUTH, GET_STATS]),
    jobs()
    {
      return JobsData;
    },
    general()
    {
      return general;
    },
    benefits()
    {
      return this.job.benefits ? this.job.benefits.items : this.general.benefits.items;
    },
    tasks()
    {
      return this.job.tasks?.items;
    },
    profile()
    {
      return this.job.profile?.items;
    },
    isAuth()
    {
      return this[HAS_AUTH];
    },
    visit()
    {
      return this[GET_STATS].uuid;
    },
    duration()
    {
      return (this[GET_STATS].dateModified - this[GET_STATS].dateCreated) / 1000;
    },

  },
  watch:
  {
    job(newVal, oldVal)
    {
      this.pageTitle(newVal.title);
      this.pageJob(`${createJsondLd(newVal)}`);
    }
  },
  mounted()
  {
    this.jobId = this.getJobId();
    this.setJob(JobsData[this.jobId]);
    this.setUid();
  },
  methods:
  {
    ...mapMutations([
      SET_TOKEN,
      SET_UUID,
      SET_DATE_CREATED,
      SET_DATE_MODIFIED,
      SET_PLATFORM]),
    startApplication()
    {
      navigator.sendBeacon(
        process.env.YAWIK_STRAPI_URL + '/api/collectors', JSON.stringify(
          {
            data: {
              job: this.job.ref,
              views: 0,
              clicks: 1,
              visits: 0
            }
          }
        )
      );
      this.apply = true;
      this.persistent = true;
      //this.$emit('apply', true);
    },
    setJob(val)
    {
      const words = val.title.split(' ');
      this.$router.push({
        name: 'job',
        params: {
          title: words[0],
        }
      });
      this.jobId = this.getJobId();
      this.job = val;
      this.job.ref = words[0];
      this.stats.job = this.job.ref;
      this.pageTitle(this.job.title);
      this.pageJob(`${createJsondLd(this.job)}`);
    },
    getJobId()
    {
      return this.$route.params.title
        ? this.jobs.findIndex((v) => v.title === this.$route.params.title + ' (m/w/d) SHK')
        : 0;
    },
    fetchData()
    {
      this.loading = true;
      this.$axios.get(process.env.YAWIK_STRAPI_URL + '/api/collectors', {
        params: {
          'pagination[page]': 1,
          'pagination[pageSize]': 30,
          sort: 'date:desc'
        }
      }
      ).then(response =>
      {
        console.log(response.data.data);
        this.statistics = response.data.data;
        //this.data;
      }).finally(() =>
      {
        this.loading = false;
      });
    },
    logout()
    {
      this.isLoggedIn = false;
      this[SET_TOKEN](null);
      localStorage.removeItem('user');
    },
    setUid()
    {
      const now = Date.now();

      if (!this.visit || (now - this[GET_STATS].dateModified) / 1000 > 1800)
      {
        // visit
        const uuid = uid();
        this[SET_UUID](uuid);
        this[SET_DATE_CREATED](now);
        this[SET_DATE_MODIFIED](now);
        navigator.sendBeacon(
          process.env.YAWIK_STRAPI_URL + '/api/collectors', JSON.stringify(
            {
              data: {
                job: this.job.ref,
                views: 1,
                clicks: 0,
                visits: 1
              }
            }
          )
        );
      }
      else
      {
        // pageview
        this[SET_DATE_MODIFIED](now);
        this.stats.duration = this.duration;
        navigator.sendBeacon(
          process.env.YAWIK_STRAPI_URL + '/api/collectors', JSON.stringify(
            {
              data: {
                job: this.job.ref,
                views: 1,
                clicks: 0,
                visits: 0
              }
            }
          )
        );
      }
    }
  }
});
</script>

<style lang="scss" scoped>

.pulse
{
  margin: 20px;
  background: #690D49;
  cursor: pointer;
  box-shadow: 0 0 0 rgba(172, 44, 204, 0.4);
  animation: pulse 1s infinite;
}

.pulse:hover
{
  animation: none;
}

@-webkit-keyframes pulse
{
  0%
  {
    -webkit-box-shadow: 0 0 0 0 rgba(204, 44, 100, 0.4);
  }

  70%
  {
    -webkit-box-shadow: 0 0 0 20px rgba(204, 169, 44, 0);
  }

  100%
  {
    -webkit-box-shadow: 0 0 0 0 rgba(204, 169, 44, 0);
  }
}

@keyframes pulse
{
  0%
  {
    -moz-box-shadow: 0 0 0 0 rgba(204, 169, 44, 0.4);
    box-shadow: 0 0 0 0 rgba(204, 169, 44, 0.4);
  }

  70%
  {
    -moz-box-shadow: 0 0 0 20px rgba(204, 169, 44, 0);
    box-shadow: 0 0 0 20px rgba(204, 169, 44, 0);
  }

  100%
  {
    -moz-box-shadow: 0 0 0 0 rgba(204, 169, 44, 0);
    box-shadow: 0 0 0 0 rgba(204, 169, 44, 0);
  }
}
</style>
